'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactGoogleMaps = require('react-google-maps');

var _lodash = require('lodash.debounce');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.sortby');

var _lodash4 = _interopRequireDefault(_lodash3);

var _TextField = require('../TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _Autocomplete = require('../Autocomplete');

var _Autocomplete2 = _interopRequireDefault(_Autocomplete);

var _kwAreas = require('./kwAreas');

require('./AddressBox.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var areasOptions = (0, _lodash4.default)(_kwAreas.areas.map(function (it) {
  return _extends({}, it, {
    groupId: it.governorate,
    label: it.englishName,
    value: it.englishName
  });
}), ['groupId', 'label']);

var AddressBox = function (_Component) {
  _inherits(AddressBox, _Component);

  function AddressBox(props) {
    _classCallCheck(this, AddressBox);

    var _this = _possibleConstructorReturn(this, (AddressBox.__proto__ || Object.getPrototypeOf(AddressBox)).call(this, props));

    _this.state = {
      open: false,
      zoom: 0,
      value: _extends({}, props.value || {})
    };

    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.geocodeAddress = (0, _lodash2.default)(_this.geocodeAddress, 1000);
    return _this;
  }

  _createClass(AddressBox, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var _this2 = this;

      if (prevProps.value != this.props.value) {
        this.setState({ value: this.props.value });

        if (this.state.zoom == 0 && this.props.value.location) this.setState({ zoom: 15 });
      }

      if (!prevState.open && this.state.open) {
        (function () {
          _this2.refs.details.querySelector('input').focus();

          var closeListener = function closeListener(e) {
            var elem = e.target;

            while (elem.parentNode != null) {
              if (elem == _this2.refs.details) return;
              elem = elem.parentNode;
            }

            e.stopImmediatePropagation();
            window.removeEventListener('click', closeListener);
            _this2.setState({ open: false });
          };

          window.addEventListener('click', closeListener);
        })();
      }

      if (prevState.open && !this.state.open) this.props.onBlur && this.props.onBlur();
    }
  }, {
    key: 'sortBlocks',
    value: function sortBlocks(blocks) {
      return (0, _lodash4.default)(blocks.map(function (it) {
        var block = Object.keys(it)[0];
        var numberPart = +block.replace(/\D/g, '') || 0;
        return {
          value: block,
          label: block,
          numberPart: numberPart
        };
      }), ['numberPart', 'value']);
    }
  }, {
    key: 'getFieldProps',
    value: function getFieldProps(fieldName) {
      var _this3 = this;

      return {
        value: this.state.value[fieldName],
        onChange: function onChange(e) {

          var stateChanges = void 0;

          if (fieldName == 'area') stateChanges = {
            value: _extends({}, _this3.state.value, {
              area: e.value,
              areaArabic: e.arabicName
            })
          };else stateChanges = {
            value: _extends({}, _this3.state.value, _defineProperty({}, fieldName, e.nativeEvent ? e.nativeEvent.target.value : e.value || e))
          };

          _this3.setState(stateChanges);
          _this3.geocodeAddress();
          _this3.props.onChange && _this3.props.onChange(stateChanges.value);
        }
      };
    }
  }, {
    key: 'geocodeAddress',
    value: function geocodeAddress() {
      var _this4 = this;

      if (!this.state.value.area) return;

      var geoCoder = new google.maps.Geocoder();
      var address = this.getFormattedAddress(['areaArabic', 'block', 'street', 'country']);

      geoCoder.geocode({ address: address }, function (results, status) {
        if (status === google.maps.GeocoderStatus.OK) {
          _this4.updateLocation(results[0].geometry.location);
          _this4.setState({ zoom: 15 });
        }
      });
    }
  }, {
    key: 'updateLocation',
    value: function updateLocation(location) {
      var newValues = _extends({}, this.state.value, {
        location: {
          latitude: location.lat(),
          longitude: location.lng()
        }
      });

      this.setState({
        value: newValues
      });

      this.props.onChange && this.props.onChange(newValues);
    }
  }, {
    key: 'getFormattedAddress',
    value: function getFormattedAddress() {
      var fields = arguments.length <= 0 || arguments[0] === undefined ? ['area', 'block', 'street', 'buildingNumber'] : arguments[0];

      var value = this.state.value;
      var elements = [];

      if (fields.includes('area') && value.area) elements.push(value.area);

      if (fields.includes('areaArabic') && value.areaArabic) elements.push(value.areaArabic);

      if (fields.includes('block') && value.block) elements.push('Block ' + value.block);

      if (fields.includes('street') && value.street) elements.push(/\d/.test(value.street) ? value.street.trim().replace(/(\d)$/, '$1 street') : value.street);

      if (fields.includes('buildingNumber') && value.buildingNumber) elements.push(value.buildingNumber);

      if (fields.includes('country')) elements.push('Kuwait');

      return elements.join(', ');
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(e) {
      this.setState({ open: true });

      this.props.onFocus && this.props.onFocus(e);
    }
  }, {
    key: 'getBlockOptions',
    value: function getBlockOptions() {
      var _this5 = this;

      if (this.state.value && this.state.value.area) {
        var areaOption = areasOptions.find(function (it) {
          return it.value == _this5.state.value.area;
        });
        return areaOption ? this.sortBlocks(areaOption.blocks) : [];
      }

      return [];
    }
  }, {
    key: 'render',
    value: function render() {
      var _this6 = this;

      var addressBox = this;
      var showMap = this.props.showMap;
      var lat = this.state.value.location.latitude || 0;
      var lng = this.state.value.location.longitude || 0;

      return _react2.default.createElement(
        'div',
        { className: 'AddressBox' },
        _react2.default.createElement(
          'div',
          { className: this.state.open && 'invisible' },
          _react2.default.createElement(_TextField2.default, {
            label: this.props.label,
            value: this.getFormattedAddress(),
            onFocus: this.handleFocus,
            onChange: function onChange() {}
          })
        ),
        this.state.open && _react2.default.createElement(
          'div',
          { ref: 'details', className: 'addressDetails' },
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(_Autocomplete2.default, _extends({
              label: 'Area',
              options: areasOptions,
              showGroups: true
            }, this.getFieldProps('area'))),
            _react2.default.createElement(
              'div',
              { className: 'secondLine' },
              _react2.default.createElement(_Autocomplete2.default, _extends({
                label: 'Block',
                showOptionsOnFocus: true,
                options: this.getBlockOptions()
              }, this.getFieldProps('block'))),
              _react2.default.createElement(_TextField2.default, _extends({
                label: 'Street'
              }, this.getFieldProps('street'))),
              _react2.default.createElement(_TextField2.default, _extends({
                label: 'Avenue',
                className: 'optional',
                placeholder: 'Optional'
              }, this.getFieldProps('avenue')))
            ),
            _react2.default.createElement(
              'div',
              { className: 'thirdLine' },
              _react2.default.createElement(
                'div',
                { className: 'pure-u-1-3' },
                _react2.default.createElement(_TextField2.default, _extends({
                  label: 'House/Building'
                }, this.getFieldProps('buildingNumber')))
              ),
              _react2.default.createElement(
                'div',
                { className: 'pure-u-1-3' },
                _react2.default.createElement(_TextField2.default, _extends({
                  label: 'Apartment/Office',
                  className: 'optional',
                  placeholder: 'Optional'
                }, this.getFieldProps('apartment')))
              ),
              _react2.default.createElement(
                'div',
                { className: 'pure-u-1-3' },
                _react2.default.createElement(_TextField2.default, _extends({
                  label: 'Floor',
                  className: 'optional',
                  placeholder: 'Optional'
                }, this.getFieldProps('floor')))
              )
            ),
            _react2.default.createElement(_TextField2.default, _extends({
              label: 'Notes/Instructions',
              placeholder: 'Optional',
              className: 'optional',
              onBlur: function onBlur() {
                return _this6.setState({ open: false });
              }
            }, this.getFieldProps('instructions')))
          ),
          !!showMap && _react2.default.createElement(_reactGoogleMaps.GoogleMapLoader, {
            containerElement: _react2.default.createElement('div', { className: 'mapContainer' }),
            googleMapElement: _react2.default.createElement(
              _reactGoogleMaps.GoogleMap,
              {
                zoom: this.state.zoom,
                center: { lat: lat, lng: lng },
                onZoomChanged: function onZoomChanged() {
                  addressBox.setState({ zoom: this.zoom });
                },
                options: { streetViewControl: false }
              },
              !!lat && _react2.default.createElement(_reactGoogleMaps.Marker, {
                position: { lat: lat, lng: lng },
                draggable: this.props.draggableMarker,
                onDragend: function onDragend(_ref) {
                  var latLng = _ref.latLng;
                  return _this6.updateLocation(latLng);
                }
              })
            )
          })
        )
      );
    }
  }]);

  return AddressBox;
}(_react.Component);

AddressBox.propTypes = {
  showMap: _react.PropTypes.bool,
  value: _react.PropTypes.shape({
    location: _react.PropTypes.shape({
      latitude: _react.PropTypes.number,
      longitude: _react.PropTypes.number
    }),
    block: _react.PropTypes.string,
    street: _react.PropTypes.string,
    apartment: _react.PropTypes.string,
    floor: _react.PropTypes.string,
    instructions: _react.PropTypes.string,
    buildingNumber: _react.PropTypes.string,
    area: _react.PropTypes.string,
    avenue: _react.PropTypes.string,
    draggableMarker: _react.PropTypes.bool
  })
};
AddressBox.defaultProps = {
  showMap: false,
  draggableMarker: true,
  value: { location: {} }
};
exports.default = AddressBox;