'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _keycode = require('keycode');

var _keycode2 = _interopRequireDefault(_keycode);

var _fuse = require('fuse.js');

var _fuse2 = _interopRequireDefault(_fuse);

var _ErrorMessage = require('../ErrorMessage');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

require('./Autocomplete.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Autocomplete = function (_Component) {
  _inherits(Autocomplete, _Component);

  function Autocomplete(props) {
    _classCallCheck(this, Autocomplete);

    var _this = _possibleConstructorReturn(this, (Autocomplete.__proto__ || Object.getPrototypeOf(Autocomplete)).call(this, props));

    var value = _this.getValue();

    _this.state = {
      filtered: _this.props.options,
      fuzzyIndex: _this.getFuzzyIndex(),
      showOptions: false,
      hoverLocked: false,
      selected: _this.props.options.find(function (it) {
        return it.value == value;
      }),
      active: 0,
      query: value
    };

    _this.filterOptions = _this.filterOptions.bind(_this);
    _this.showOptions = _this.showOptions.bind(_this);
    _this.handleBlur = _this.handleBlur.bind(_this);
    _this.handleArrowKeys = _this.handleArrowKeys.bind(_this);
    _this.handleArrowClick = _this.handleArrowClick.bind(_this);
    _this.handleFocus = _this.handleFocus.bind(_this);
    return _this;
  }

  _createClass(Autocomplete, [{
    key: 'getLabel',
    value: function getLabel() {
      var value = this.getValue();

      if (!this.props.options) return value;

      var foundOption = this.props.options.find(function (it) {
        return it.value == value;
      });
      return foundOption ? foundOption.label : value;
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      return this.props.value ? this.props.value.value || this.props.value : '';
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.options != this.props.options) this.setState({ fuzzyIndex: this.getFuzzyIndex() });

      if (prevProps.value != this.props.value && (!prevProps.value || !this.props.value || prevProps.value.value != this.props.value.value)) {
        var value = this.getValue();
        var label = this.getLabel();
        var selected = this.props.options.find(function (it) {
          return it.value == value;
        });

        this.setState({
          selected: selected,
          query: label
        });

        if (selected && this.props.onChange) this.props.onChange(selected);
      }

      var optionList = this.refs.optionList;
      var selectedOption = optionList && optionList.querySelector('.active');

      if (!selectedOption) return;

      var optsHeight = optionList.offsetHeight;
      var scrollTop = optionList.scrollTop;
      var selOffset = selectedOption.offsetTop;
      var selHeight = selectedOption.offsetHeight;

      if (selOffset + selHeight > scrollTop + optsHeight) optionList.scrollTop += selOffset + selHeight - scrollTop - optsHeight;

      if (selOffset <= scrollTop) optionList.scrollTop = selOffset;
    }
  }, {
    key: 'getFuzzyIndex',
    value: function getFuzzyIndex() {
      var options = this.props.options || [];
      var settings = _extends({
        keys: ['label'],
        threshold: .3,
        shouldSort: false
      }, this.props.fuzzySettings || {});

      return new _fuse2.default(options, settings);
    }
  }, {
    key: 'filterOptions',
    value: function filterOptions(e) {
      var keyCode = e ? e.keyCode : -1 || -1;

      var query = this.state.query;

      switch (keyCode) {
        case (0, _keycode2.default)('LEFT'):
        case (0, _keycode2.default)('RIGHT'):
          return true;

        case (0, _keycode2.default)('ESC'):
        case (0, _keycode2.default)('ENTER'):
          this.handleBlur();
          return true;

        case (0, _keycode2.default)('DOWN'):
        case (0, _keycode2.default)('UP'):
          this.showOptions();
          this.setState({
            filtered: query ? this.state.fuzzyIndex.search(query) : this.props.options
          });
          return true;

        case (0, _keycode2.default)('TAB'):
          return true;
      }

      this.setState({
        filtered: query ? this.state.fuzzyIndex.search(query) : this.props.options,
        active: 0,
        showOptions: true
      });

      return true;
    }
  }, {
    key: 'showOptions',
    value: function showOptions() {
      this.setState({ showOptions: true });
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur() {
      this.setState({ showOptions: false });
      this.props.onBlur && this.props.onBlur();
    }
  }, {
    key: 'hoverOption',
    value: function hoverOption(index) {
      if (!this.state.hoverLocked) this.setState({ active: index });
    }
  }, {
    key: 'chooseCurrent',
    value: function chooseCurrent() {
      if (this.state.active > this.state.filtered.length - 1) return;

      var selected = this.state.filtered[this.state.active];

      this.setState({ query: selected.label });

      if (this.props.onChange && this.state.selected != selected) this.props.onChange(selected);

      this.setState({ selected: selected, showOptions: false });
    }
  }, {
    key: 'handleArrowKeys',
    value: function handleArrowKeys(e) {
      switch (e.keyCode) {
        case (0, _keycode2.default)('DOWN'):
          this.lockHover();
          e.preventDefault();
          this.setState({ active: Math.min(this.state.active + 1, this.state.filtered.length - 1) });
          return false;

        case (0, _keycode2.default)('UP'):
          this.lockHover();
          e.preventDefault();
          this.setState({ active: Math.max(0, this.state.active - 1) });
          return false;

        case (0, _keycode2.default)('ENTER'):
          if (this.state.showOptions) e.preventDefault();
          this.chooseCurrent();
          return true;

        case (0, _keycode2.default)('TAB'):
          if (this.state.showOptions) this.chooseCurrent();
          return true;
      }

      return true;
    }
  }, {
    key: 'lockHover',
    value: function lockHover() {
      var _this2 = this;

      var unlockHover = function unlockHover() {
        _this2.setState({ hoverLocked: false });
        window.removeEventListener('mousemove', unlockHover);
      };

      window.addEventListener('mousemove', unlockHover);
      this.setState({ hoverLocked: true });
    }
  }, {
    key: 'renderFiltered',
    value: function renderFiltered() {
      var _this3 = this;

      var lastGroup = null;

      return this.state.filtered.reduce(function (prev, it, index) {
        if (_this3.props.showGroups && it.groupId != lastGroup) {
          lastGroup = it.groupId;
          prev.push(_react2.default.createElement(
            'li',
            {
              key: 'group_' + it.groupId,
              className: 'group'
            },
            it.groupId
          ));
        }

        prev.push(_react2.default.createElement(
          'li',
          {
            key: it.value,
            className: 'menuItem ' + (index == _this3.state.active && 'active'),
            onMouseOver: function onMouseOver() {
              return _this3.hoverOption(index);
            },
            onMouseDown: function onMouseDown() {
              return _this3.chooseCurrent(index);
            }
          },
          it.label
        ));
        return prev;
      }, []);
    }
  }, {
    key: 'handleArrowClick',
    value: function handleArrowClick() {
      if (!this.state.showOptions) {
        this.setState({ showOptions: true, filtered: this.props.options });
        this.refs.query.focus();
      }
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(e) {
      if (this.props.showOptionsOnFocus) this.setState({ showOptions: true, filtered: this.props.options });

      this.props.onFocus && this.props.onFocus(e);
    }
  }, {
    key: 'renderOptions',
    value: function renderOptions() {
      var shouldShowOptions = this.state.showOptions && this.state.filtered.length > 0;

      if (shouldShowOptions) return _react2.default.createElement(
        'ul',
        { className: 'menu ' + (this.props.showGroups && 'grouped'), ref: 'optionList' },
        this.renderFiltered()
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      return _react2.default.createElement(
        'div',
        { className: 'Autocomplete' },
        _react2.default.createElement(_Label2.default, { content: this.props.label }),
        _react2.default.createElement(
          'div',
          { className: 'inputContainer' },
          _react2.default.createElement('input', {
            ref: 'query',
            onKeyDown: this.handleArrowKeys,
            onKeyUp: this.filterOptions,
            onBlur: this.handleBlur,
            onFocus: this.handleFocus,
            value: this.state.query,
            onChange: function onChange(e) {
              return _this4.setState({ query: e.target.value });
            },
            placeholder: this.props.placeholder,
            autoComplete: 'off'
          }),
          _react2.default.createElement('i', { className: 'arrow', onClick: this.handleArrowClick }),
          this.renderOptions()
        ),
        _react2.default.createElement(_ErrorMessage2.default, { error: this.props.error })
      );
    }
  }]);

  return Autocomplete;
}(_react.Component);

Autocomplete.propTypes = {
  options: _react.PropTypes.array,
  showOptionsOnFocus: _react.PropTypes.bool,
  fuzzySettings: _react.PropTypes.shape({
    keys: _react.PropTypes.array,
    threshold: _react.PropTypes.number,
    shouldSort: _react.PropTypes.bool
  }),
  showGroups: _react.PropTypes.bool,
  placeholder: _react.PropTypes.string,
  onChange: _react.PropTypes.func
};
exports.default = Autocomplete;