'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./CircularImage.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CircularImage = function (_Component) {
  _inherits(CircularImage, _Component);

  function CircularImage() {
    _classCallCheck(this, CircularImage);

    return _possibleConstructorReturn(this, (CircularImage.__proto__ || Object.getPrototypeOf(CircularImage)).apply(this, arguments));
  }

  _createClass(CircularImage, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.loadImage();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (prevProps.src != this.props.src) this.loadImage();
    }
  }, {
    key: 'loadImage',
    value: function loadImage() {
      var _this2 = this;

      this.setState({
        imageStyle: {}
      });

      var image = new Image();

      image.onload = function () {
        _this2.setState({
          imageSrc: _this2.props.src,
          imageStyle: image.width > image.height ? { height: '100%', width: 'auto', maxWidth: 'inherit' } : { width: '100%', height: 'auto', maxHeight: 'inherit' }
        });
      };

      image.src = this.props.src;
    }
  }, {
    key: 'render',
    value: function render() {
      var className = (0, _classnames2.default)('CircularImage', this.props.className, { hoverZoom: this.props.hoverZoom });

      var style = {
        width: this.props.size,
        height: this.props.size,
        background: !this.state.imageSrc && 'rgba(0,0,0,.3)'
      };

      return _react2.default.createElement(
        'div',
        { className: className, style: style },
        _react2.default.createElement('img', {
          src: this.state.imageSrc,
          alt: this.state.imageSrc && this.props.alt,
          style: this.state.imageStyle
        })
      );
    }
  }]);

  return CircularImage;
}(_react.Component);

CircularImage.propTypes = {
  src: _react.PropTypes.string.isRequired,
  size: _react.PropTypes.number.isRequired,
  hoverZoom: _react.PropTypes.bool
};
exports.default = CircularImage;