'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('./ContextMenu.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ContextMenu = function (_Component) {
  _inherits(ContextMenu, _Component);

  function ContextMenu(props) {
    _classCallCheck(this, ContextMenu);

    var _this = _possibleConstructorReturn(this, (ContextMenu.__proto__ || Object.getPrototypeOf(ContextMenu)).call(this, props));

    _this.state = {
      shouldShowMenu: false,
      menuX: 0,
      menuY: 0
    };

    _this.handleOpenIntent = _this.handleOpenIntent.bind(_this);
    return _this;
  }

  _createClass(ContextMenu, [{
    key: 'handleOpenIntent',
    value: function handleOpenIntent(e) {
      var _this2 = this;

      if (!this.props.enabled) return;

      e.preventDefault();

      var shouldShowMenu = !this.state.shouldShowMenu;

      this.setState({
        shouldShowMenu: shouldShowMenu,
        menuX: e.pageX + 2,
        menuY: e.pageY + 2
      });

      if (shouldShowMenu) {
        var closeListener = function closeListener(e) {
          var elem = e.target;

          while (elem.parentNode != null) {
            if (elem == _this2.refs.root) return;
            elem = elem.parentNode;
          }

          window.removeEventListener('click', closeListener);
          window.removeEventListener('contextmenu', closeListener);

          _this2.setState({ shouldShowMenu: false });
        };

        setTimeout(function () {
          window.addEventListener('click', closeListener);
          window.addEventListener('contextmenu', closeListener);
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var menuStyle = _defineProperty({}, this.props.align, 0);

      return _react2.default.createElement(
        'div',
        {
          className: 'ContextMenu',
          onContextMenu: this.handleOpenIntent,
          onClick: function onClick(e) {
            return _this3.props.leftClick && _this3.handleOpenIntent(e);
          }
        },
        this.props.children,
        this.state.shouldShowMenu && _react2.default.createElement(
          'ul',
          { className: 'menu', style: menuStyle },
          this.props.options.map(function (opt) {
            return _react2.default.createElement(
              'li',
              { key: opt.label, className: 'item', onClick: opt.action },
              opt.label
            );
          })
        )
      );
    }
  }]);

  return ContextMenu;
}(_react.Component);

ContextMenu.propTypes = {
  options: _react.PropTypes.array,
  enabled: _react.PropTypes.bool,
  leftClick: _react.PropTypes.bool,
  align: _react.PropTypes.oneOf(['left', 'right'])
};
ContextMenu.defaultProps = {
  options: [],
  enabled: true,
  leftClick: false,
  align: 'right'
};
exports.default = ContextMenu;