'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _webcamjs = require('webcamjs');

var _webcamjs2 = _interopRequireDefault(_webcamjs);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

var _ErrorMessage = require('../ErrorMessage');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _dataUriToBlob = require('./dataUriToBlob');

var _dataUriToBlob2 = _interopRequireDefault(_dataUriToBlob);

require('./FileInput.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FileInput = function (_Component) {
  _inherits(FileInput, _Component);

  function FileInput(props) {
    _classCallCheck(this, FileInput);

    var _this = _possibleConstructorReturn(this, (FileInput.__proto__ || Object.getPrototypeOf(FileInput)).call(this, props));

    _this.state = {
      id: Math.random().toString(30).substr(2),
      cameraLayerOpen: false,
      frozen: false
    };

    _this.handleClickOut = _this.handleClickOut.bind(_this);
    _this.openCameraLayer = _this.openCameraLayer.bind(_this);
    _this.freeze = _this.freeze.bind(_this);
    _this.unfreeze = _this.unfreeze.bind(_this);
    _this.capture = _this.capture.bind(_this);
    _this.handleUpload = _this.handleUpload.bind(_this);
    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  _createClass(FileInput, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (!prevState.cameraLayerOpen && this.state.cameraLayerOpen) {
        _webcamjs2.default.set({
          width: 640,
          height: 480,
          flip_horiz: true,
          image_format: 'jpeg',
          jpeg_quality: 95,
          swfURL: '/webcam.swf'
        });

        _webcamjs2.default.attach('#camera' + this.state.id);
      }

      if (prevState.cameraLayerOpen && !this.state.cameraLayerOpen) _webcamjs2.default.reset();
    }
  }, {
    key: 'openCameraLayer',
    value: function openCameraLayer() {
      _webcamjs2.default.unfreeze();

      this.setState({
        cameraLayerOpen: true,
        frozen: false
      });
    }
  }, {
    key: 'freeze',
    value: function freeze() {
      _webcamjs2.default.freeze();
      this.setState({ frozen: true });
    }
  }, {
    key: 'unfreeze',
    value: function unfreeze() {
      _webcamjs2.default.unfreeze();
      this.setState({ frozen: false });
    }
  }, {
    key: 'capture',
    value: function capture() {
      var _this2 = this;

      _webcamjs2.default.snap(function (dataUri) {
        _this2.handleUpload(dataUri);
        _this2.setState({ cameraLayerOpen: false });
      });
    }
  }, {
    key: 'handleClickOut',
    value: function handleClickOut(e) {
      if (e.target == this.refs.cameraLayerContainer) this.setState({ cameraLayerOpen: false });
    }
  }, {
    key: 'handleUpload',
    value: function handleUpload(it) {
      var _this3 = this;

      var file = typeof it == 'string' ? Object.assign((0, _dataUriToBlob2.default)(it), { name: 'photo.jpg' }) : it.target.files[0];

      if (file == null) {
        this.refs.finalUrl.value = '';
        return;
      }

      this.setState({ isLoading: true });

      new Promise(function (resolve) {
        resolve(typeof _this3.props.uploadUrl == 'function' ? _this3.props.uploadUrl(file.name) : _this3.props.uploadUrl);
      }).then(function (uploadUrl) {

        var data = new FormData();
        data.append('file', file);

        _axios2.default.put(uploadUrl, data).then(function (res) {
          _this3.setState({ isLoading: false });

          var fileUrl = res.data;

          _this3.refs.fileUrl.value = fileUrl;
          _this3.props.onChange && _this3.props.onChange(fileUrl);
          _this3.props.onBlur && _this3.props.onBlur();

          _this3.setState({
            fileUrl: fileUrl,
            error: undefined
          });
        }).catch(function (err) {
          _this3.setState({ isLoading: false });

          _this3.refs.fileInput.value = '';
          _this3.refs.fileUrl.value = '';

          _this3.setState({
            fileUrl: '',
            error: 'Upload failed'
          });
        });
      });
    }
  }, {
    key: 'handleClick',
    value: function handleClick(e) {
      this.props.onFocus && this.props.onFocus(e);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'FileInput ' + this.props.className },
        _react2.default.createElement(_Label2.default, { content: this.props.label }),
        _react2.default.createElement(
          'div',
          { className: 'inputContainer' },
          _react2.default.createElement('input', {
            ref: 'fileInput',
            type: 'file',
            id: this.state.id,
            accept: this.props.types,
            onChange: this.handleUpload,
            onBlur: function onBlur() {
              return console.log('blur');
            }
          }),
          _react2.default.createElement('input', {
            ref: 'fileUrl',
            type: 'text',
            name: this.props.name
          }),
          _react2.default.createElement(
            'label',
            { htmlFor: this.state.id },
            this.renderButtonContent()
          ),
          this.renderCameraButton(),
          this.renderPreviewLink()
        ),
        _react2.default.createElement(_ErrorMessage2.default, { error: this.props.error || this.state.error }),
        this.renderCameraLayer()
      );
    }
  }, {
    key: 'renderButtonContent',
    value: function renderButtonContent() {
      var loading = this.state.isLoading;
      var fileUrl = this.state.fileUrl || this.props.value;

      if (loading) return _react2.default.createElement(
        'span',
        null,
        'Uploading...'
      );else return _react2.default.createElement(
        'a',
        { disabled: loading, onClick: this.handleClick },
        _react2.default.createElement(
          'i',
          { className: 'material-icons' },
          fileUrl ? 'check' : 'attach_file'
        ),
        fileUrl ? 'Change file...' : 'Select file...'
      );
    }
  }, {
    key: 'renderCameraButton',
    value: function renderCameraButton() {
      if (this.props.camera && !this.state.isLoading) return _react2.default.createElement(
        'a',
        { type: 'button', className: 'cameraButton', onClick: this.openCameraLayer },
        _react2.default.createElement(
          'i',
          { className: 'material-icons' },
          'camera_alt'
        )
      );
    }
  }, {
    key: 'renderPreviewLink',
    value: function renderPreviewLink() {
      var fileUrl = this.state.fileUrl || this.props.value;

      if (fileUrl) return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'a',
          { className: 'previewLink', href: fileUrl, target: '_blank' },
          'Preview file'
        )
      );
    }
  }, {
    key: 'renderCameraLayer',
    value: function renderCameraLayer() {
      return _react2.default.createElement(
        'div',
        {
          ref: 'cameraLayerContainer',
          className: 'cameraLayer ' + (this.state.cameraLayerOpen && 'open'),
          onClick: this.handleClickOut
        },
        _react2.default.createElement(
          'div',
          { className: 'cameraBox' },
          _react2.default.createElement('div', { className: 'cameraImage', id: 'camera' + this.state.id }),
          _react2.default.createElement(
            'div',
            { className: 'cameraButtons' },
            !this.state.frozen && _react2.default.createElement(
              'i',
              { className: 'material-icons shootIcon', onClick: this.freeze },
              'camera'
            ),
            this.state.frozen && _react2.default.createElement(
              'i',
              { className: 'material-icons', onClick: this.unfreeze },
              'close'
            ),
            this.state.frozen && _react2.default.createElement(
              'i',
              { className: 'material-icons', onClick: this.capture },
              'check'
            )
          )
        )
      );
    }
  }]);

  return FileInput;
}(_react.Component);

FileInput.propTypes = {
  prefix: _react.PropTypes.string,
  label: _react.PropTypes.string,
  types: _react.PropTypes.string,
  camera: _react.PropTypes.bool,
  onChange: _react.PropTypes.func,
  uploadUrl: _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.string])
};
exports.default = FileInput;