'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('./Notifier.scss');

var _Animated = require('../Animated');

var _Animated2 = _interopRequireDefault(_Animated);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var sounds = {
  neutral: null,
  failure: null
};

var Notifier = function (_Component) {
  _inherits(Notifier, _Component);

  function Notifier(props) {
    _classCallCheck(this, Notifier);

    var _this = _possibleConstructorReturn(this, (Notifier.__proto__ || Object.getPrototypeOf(Notifier)).call(this, props));

    window.addEventListener('__notifier_update', function () {
      _this.forceUpdate();
    });

    sounds.neutral = new Audio(props.neutralSound);
    sounds.failure = new Audio(props.failureSound);
    return _this;
  }

  _createClass(Notifier, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'Notifier' },
        _react2.default.createElement(
          _Animated2.default,
          null,
          Notifier.messages.map(function (it) {
            return _react2.default.createElement(
              'div',
              {
                className: it.type,
                key: it.id,
                onClick: function onClick() {
                  return Notifier.removeMessage(it);
                }
              },
              _react2.default.createElement(
                'div',
                { className: 'type' },
                it.type
              ),
              it.message
            );
          })
        )
      );
    }
  }], [{
    key: 'pushMessage',
    value: function pushMessage(item) {
      item.id = Date.now();

      Notifier.messages.push(item);

      window.dispatchEvent(new Event('__notifier_update'));

      if (item.type == 'error' && sounds.failure) {
        sounds.failure.volume = .2;
        sounds.failure.play();
      } else if (item.type != 'error' && sounds.neutral) {
        sounds.neutral.volume = .2;
        sounds.neutral.play();
      }

      var timeout = item.timeout || 3000 + item.message.split(' ').length * 500;

      setTimeout(function () {
        Notifier.removeMessage(item);
      }, timeout);
    }
  }, {
    key: 'removeMessage',
    value: function removeMessage(item) {
      Notifier.messages = Notifier.messages.filter(function (it) {
        return it != item;
      });
      window.dispatchEvent(new Event('__notifier_update'));
    }
  }, {
    key: 'error',
    value: function error(message) {
      var timeout = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];

      Notifier.pushMessage({ message: message, timeout: timeout, type: 'error' });
    }
  }, {
    key: 'info',
    value: function info(message) {
      var timeout = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];

      Notifier.pushMessage({ message: message, timeout: timeout, type: 'info' });
    }
  }, {
    key: 'success',
    value: function success(message) {
      var timeout = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];

      Notifier.pushMessage({ message: message, timeout: timeout, type: 'success' });
    }
  }]);

  return Notifier;
}(_react.Component);

Notifier.messages = [];
Notifier.propTypes = {
  neutralSound: _react.PropTypes.string,
  failureSound: _react.PropTypes.string
};
exports.default = Notifier;