'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMaskedinput = require('react-maskedinput');

var _reactMaskedinput2 = _interopRequireDefault(_reactMaskedinput);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

var _ErrorMessage = require('../ErrorMessage');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./TextField.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextField = function (_Component) {
  _inherits(TextField, _Component);

  function TextField() {
    _classCallCheck(this, TextField);

    return _possibleConstructorReturn(this, (TextField.__proto__ || Object.getPrototypeOf(TextField)).apply(this, arguments));
  }

  _createClass(TextField, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props;
      var label = _props.label;
      var mask = _props.mask;
      var error = _props.error;
      var currency = _props.currency;
      var decimalPlaces = _props.decimalPlaces;
      var className = _props.className;

      var props = _objectWithoutProperties(_props, ['label', 'mask', 'error', 'currency', 'decimalPlaces', 'className']);

      if (currency) {
        props.onFocus = function (e) {
          var target = e.nativeEvent.target;
          target.value = target.value || '';
        };

        props.onChange = function (e) {
          var target = e.nativeEvent.target;
          var prevOnChange = _this2.props.onChange;
          var clearValue = target.value.replace(/\D/, '');
          decimalPlaces = decimalPlaces || 2;

          target.selectionStart = target.selectionEnd = target.value.length;

          clearValue = clearValue ? parseInt(clearValue, 10) / Math.pow(10, decimalPlaces) : 0;

          prevOnChange && prevOnChange(clearValue.toFixed(decimalPlaces));
        };
      }

      className = (0, _classnames2.default)('TextField', className, { currency: currency, error: error });

      return _react2.default.createElement(
        'div',
        { className: className },
        _react2.default.createElement(_Label2.default, { content: label }),
        mask ? _react2.default.createElement(_reactMaskedinput2.default, _extends({ mask: mask }, props)) : _react2.default.createElement('input', props),
        _react2.default.createElement(_ErrorMessage2.default, { error: error })
      );
    }
  }]);

  return TextField;
}(_react.Component);

TextField.propTypes = {
  currency: _react.PropTypes.bool,
  decimalPlaces: _react.PropTypes.number,
  type: _react.PropTypes.string,
  value: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]).isRequired,
  onChange: _react.PropTypes.func,
  autoComplete: _react.PropTypes.string,
  prefix: _react.PropTypes.string,
  suffix: _react.PropTypes.string
};
TextField.defaultProps = {
  value: '',
  type: 'text',
  autoComplete: 'off',
  onChange: new Function()
};
exports.default = TextField;