'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

var _ErrorMessage = require('../ErrorMessage');

var _ErrorMessage2 = _interopRequireDefault(_ErrorMessage);

require('./ToggleGroup.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ToggleGroup = function (_Component) {
  _inherits(ToggleGroup, _Component);

  function ToggleGroup(props) {
    _classCallCheck(this, ToggleGroup);

    var _this = _possibleConstructorReturn(this, (ToggleGroup.__proto__ || Object.getPrototypeOf(ToggleGroup)).call(this, props));

    _this.state = { error: props.error || '' };
    _this.selectOption = _this.selectOption.bind(_this);
    return _this;
  }

  _createClass(ToggleGroup, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var _this2 = this;

      if (this.props.error != prevProps.error) setTimeout(function () {
        return _this2.setState({ error: _this2.props.error });
      }, 50);
    }
  }, {
    key: 'selectOption',
    value: function selectOption(option) {
      var _this3 = this;

      if (this.props.value == option.value) option = null;

      this.props.onChange && this.props.onChange(option.value);

      setTimeout(function () {
        _this3.props.onFocus && _this3.props.onFocus();
        _this3.props.onBlur && _this3.props.onBlur();
      }, 0);
    }
  }, {
    key: 'renderButtons',
    value: function renderButtons() {
      var _this4 = this;

      return this.props.options.map(function (opt) {
        var optClassName = (0, _classnames2.default)({ selected: opt.value == _this4.props.value });

        return _react2.default.createElement(
          'button',
          {
            key: opt.value + ';' + opt.label,
            type: 'button',
            className: optClassName,
            onClick: function onClick() {
              return _this4.selectOption(opt);
            }
          },
          opt.label
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { className: 'ToggleGroup' },
        _react2.default.createElement(_Label2.default, { content: this.props.label }),
        _react2.default.createElement(
          'div',
          { className: 'buttonsContainer' },
          this.renderButtons()
        ),
        _react2.default.createElement(_ErrorMessage2.default, { error: this.state.error })
      );
    }
  }]);

  return ToggleGroup;
}(_react.Component);

ToggleGroup.propTypes = {
  options: _react.PropTypes.array
};
exports.default = ToggleGroup;