'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _AddressBox = require('./components/AddressBox');

var _AddressBox2 = _interopRequireDefault(_AddressBox);

var _Autocomplete = require('./components/Autocomplete');

var _Autocomplete2 = _interopRequireDefault(_Autocomplete);

var _FormSection = require('./components/FormSection');

var _FormSection2 = _interopRequireDefault(_FormSection);

var _TextField = require('./components/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _ToggleGroup = require('./components/ToggleGroup');

var _ToggleGroup2 = _interopRequireDefault(_ToggleGroup);

var _CircularImage = require('./components/CircularImage');

var _CircularImage2 = _interopRequireDefault(_CircularImage);

var _FileInput = require('./components/FileInput');

var _FileInput2 = _interopRequireDefault(_FileInput);

var _ContextMenu = require('./components/ContextMenu');

var _ContextMenu2 = _interopRequireDefault(_ContextMenu);

var _reactFormy = require('react-formy');

var _reactFormy2 = _interopRequireDefault(_reactFormy);

var _validate = require('validate.js');

var _validate2 = _interopRequireDefault(_validate);

require('./demo.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Demo = function (_Component) {
  _inherits(Demo, _Component);

  function Demo() {
    _classCallCheck(this, Demo);

    return _possibleConstructorReturn(this, (Demo.__proto__ || Object.getPrototypeOf(Demo)).apply(this, arguments));
  }

  _createClass(Demo, [{
    key: 'onSubmit',
    value: function onSubmit(values) {
      console.log(values);
    }
  }, {
    key: 'render',
    value: function render() {
      var field = this.props.field;
      var arrayField = this.props.arrayField;
      var form = this.props.form;
      var handleSubmit = this.props.handleSubmit;
      var handleAddClick = function handleAddClick() {
        return arrayField('items').push({ name: 'john' });
      };

      var items = form.items || [];
      var toggleOptions = [{ value: '1', label: 'One' }, { value: '2', label: 'Two' }];

      var transformation = JSON.stringify({
        width: 250,
        height: 250,
        crop: 'thumb',
        gravity: 'face'
      });

      var uploadUrl = 'http://localhost:3030/upload?transformation=' + transformation;

      return _react2.default.createElement(
        'div',
        { className: 'Demo' },
        'Armada UI Demo',
        _react2.default.createElement(
          'div',
          { className: 'pure-g' },
          _react2.default.createElement(
            'div',
            { className: 'pure-u-2-3' },
            _react2.default.createElement(
              'form',
              { onSubmit: handleSubmit(this.onSubmit) },
              _react2.default.createElement(
                _FormSection2.default,
                { title: 'Lorem ipsum dolor' },
                _react2.default.createElement(_TextField2.default, _extends({
                  label: 'Name'
                }, field('user.name'))),
                _react2.default.createElement(_TextField2.default, _extends({
                  label: 'Birthday',
                  mask: '11/11/1111'
                }, field('birthday'))),
                _react2.default.createElement(_AddressBox2.default, _extends({
                  label: 'Address',
                  showMap: true
                }, field('address'))),
                _react2.default.createElement(_ToggleGroup2.default, _extends({
                  label: 'Toggle',
                  options: toggleOptions
                }, field('toggle'))),
                _react2.default.createElement(
                  'div',
                  { className: 'pure-g' },
                  _react2.default.createElement(
                    'div',
                    { className: 'pure-u-1-2' },
                    _react2.default.createElement(_Autocomplete2.default, {
                      label: 'Dropdown',
                      options: [{ value: '1', label: 'Lorem' }, { value: '2', label: 'Ipsum' }]
                    })
                  ),
                  _react2.default.createElement(
                    'div',
                    { className: 'pure-u-1-2' },
                    _react2.default.createElement(_TextField2.default, _extends({
                      label: 'Value',
                      currency: true,
                      decimalPlaces: 3
                    }, field('value')))
                  )
                ),
                _react2.default.createElement(
                  'div',
                  { className: 'pure-g' },
                  _react2.default.createElement(
                    'div',
                    { className: 'pure-u-1-2' },
                    _react2.default.createElement(_FileInput2.default, _extends({
                      label: 'Contract',
                      camera: true,
                      types: 'application/pdf,image/*',
                      uploadUrl: uploadUrl
                    }, field('photo')))
                  ),
                  _react2.default.createElement(
                    'div',
                    { className: 'pure-u-1-2' },
                    _react2.default.createElement(_Autocomplete2.default, _extends({
                      label: 'Dropdown',
                      showOptionsOnFocus: true,
                      options: [{ value: '1', label: 'Lorem' }, { value: '2', label: 'Ipsum' }]
                    }, field('dropdown'), {
                      error: 'teste'
                    }))
                  )
                ),
                _react2.default.createElement(
                  'div',
                  null,
                  _react2.default.createElement(
                    _ContextMenu2.default,
                    {
                      leftClick: true,
                      align: 'left',
                      options: [{ label: 'Lorem ipsum', action: function action() {
                          return console.log('lorem ipsum');
                        } }, { label: 'Dolor sit', action: function action() {
                          return console.log('dolor sit');
                        } }]
                    },
                    _react2.default.createElement(
                      'button',
                      { type: 'button' },
                      'Lorem Ipsum'
                    )
                  )
                ),
                _react2.default.createElement('br', null),
                _react2.default.createElement('br', null),
                _react2.default.createElement(_CircularImage2.default, { src: field('photo').value || '', hoverZoom: true, size: 50 }),
                _react2.default.createElement(_CircularImage2.default, { src: 'http://goo.gl/ZLzo5H', hoverZoom: true, size: 50 }),
                _react2.default.createElement('br', null),
                _react2.default.createElement('br', null),
                items.map(function (it, i) {
                  return _react2.default.createElement(_TextField2.default, _extends({ key: i }, field('items[].name', i)));
                }),
                _react2.default.createElement(
                  'button',
                  { type: 'button', onClick: handleAddClick },
                  'Add'
                )
              ),
              _react2.default.createElement('br', null),
              _react2.default.createElement('br', null),
              _react2.default.createElement(
                'button',
                { type: 'submit' },
                'Save info'
              )
            )
          )
        )
      );
    }
  }], [{
    key: 'validateForm',
    value: function validateForm(values) {
      return (0, _validate2.default)(values, {
        'user.name': { presence: true },
        'value': { numericality: { greaterThan: 2 } }
      });
    }
  }]);

  return Demo;
}(_react.Component);

var ConnectedDemo = (0, _reactFormy2.default)(Demo);

_reactDom2.default.render(_react2.default.createElement(ConnectedDemo, null), document.querySelector('#main'));